screen_controls = {}

function screen_controls:load()
	self.buttons = {
					up = {x = 50, y = 400, width = 100, height = 20, op = 255, 
						  img = love.graphics.newImage("assets/touch_controls/touch_up.png")},
					down = {x = 50, y = 520, width = 100, height = 20, op = 255, 
						  img = love.graphics.newImage("assets/touch_controls/touch_down.png")},
					left = {x = 30, y = 420, width = 20, height = 100, op = 255, 
						  img = love.graphics.newImage("assets/touch_controls/touch_left.png")},
					right = {x = 150, y = 420, width = 20, height = 100, op = 255, 
						  img = love.graphics.newImage("assets/touch_controls/touch_right.png")},
					shoot = {x = 580, y = 400, width = 80, height = 80, op = 255, 
						  img = love.graphics.newImage("assets/touch_controls/touch_shoot.png")},
					reload = {x = 660, y = 480, width = 80, height = 80, op = 255, 
						  img = love.graphics.newImage("assets/touch_controls/touch_reload.png")}
					}

	_up_touch = self.buttons.up
	_down_touch = self.buttons.down
	_left_touch = self.buttons.left
	_right_touch = self.buttons.right

	_shoot_touch = self.buttons.shoot
	_reload_touch = self.buttons.reload

	_touch_box = { 
				  x = 0,
				  y = 0, 
				  width = 25, 
				  height = 25
			     }
end

function screen_controls:update(dt)
	screen_controls:opacity()
end

function screen_controls:draw()
	for i, b in pairs(self.buttons) do
		love.graphics.setColor(255, 255, 255, b.op)
		love.graphics.draw(b.img, b.x, b.y)
	end

	-- love.graphics.setColor(255, 255, 255)
	-- love.graphics.print("Current_state: "..current_state, 500, 0)
	-- love.graphics.rectangle("fill", _touch_box.x, _touch_box.y, _touch_box.width, _touch_box.height)
end

function screen_controls:touched(x, y, b, istouch)
	_touch_box.x = x
	_touch_box.y = y
	
	if current_state == states.action then 
		if CheckCollisions(_touch_box, _up_touch) then 
			player.current_state = player.states.up
			player.current_image = player.images.up_img
		end

		if CheckCollisions(_touch_box, _down_touch) then 
			player.current_state = player.states.down
			player.current_image = player.images.down_img
		end

		if CheckCollisions(_touch_box, _left_touch) then 
			player.current_state = player.states.left
			player.current_image = player.images.left_img
		end

		if CheckCollisions(_touch_box, _right_touch) then 
			player.current_state = player.states.right
			player.current_image = player.images.right_img
		end
	end

	screen_controls:settings(x, y, b, istouch)
	screen_controls:menu(x, y, b, istouch)
end

function screen_controls:settings(x, y, b, istouch)
	if current_state == states.settings then
		if CheckCollisions(_touch_box, _music) and _music.toggle == "Off" then 
			music_on()
			touchbox_reset()
		end

		if CheckCollisions(_touch_box, _music) and _music.toggle == "On" then 
			music_off()
			touchbox_reset()
		end

		if CheckCollisions(_touch_box, _gfx) and _gfx.toggle == "Bad" then 
			gfx_on()
			touchbox_reset()
		end

		if CheckCollisions(_touch_box, _gfx) and _gfx.toggle == "Gud" then 
			gfx_off()
			touchbox_reset()
		end
	end
end

function screen_controls:menu(x, y, b, istouch)
	if current_state == states.menu then
		if CheckCollisions(_touch_box, _start) then 
			current_state = states.action
			touchbox_reset()
		end

		if CheckCollisions(_touch_box, _settings) then 
			current_state = states.settings
			touchbox_reset()
		end

		if CheckCollisions(_touch_box, _quit) then 
			love.quit()
		end
	end
end

function screen_controls:anim_reset(x, y, b , istouch)
	if not istouch then 
		player:touchbox_reset_anim(player.current_state)
	end
end

function screen_controls:opacity()
	for i, b in pairs(self.buttons) do 
		if CheckCollisions(_touch_box, b) then 
			b.op = 255
		else
			b.op = 100
		end
	end
end

function touchbox_reset()
	_touch_box.x = 0
	_touch_box.y = 0
end